clear; clc;close all

%%%%%%%%%%%%%%%%%%%%%%%%%%
% NOTE TO SELF:
% 0/ RUN PARAM AND SOLVESAFE IF CHANGING SS
% 1/ PERHAPS MODIFY HOME-CHOICE PROBABILITY WHEN MAKING OCC CHOICE
%%%%%%%%%%%%%%%%%%%%%%%%%%

%---------------------------
%% COUNTRY SPECIFIC SHIT
%---------------------------
% demographics: input from sk and uk separately
%---------------------------
folder = 'figures_sk/';

%http://27.101.213.4/ageStatMonth.do
%0-14: 6,348,914	
p.pop = 37957316;
p.o0 = 7425673;
p.o0 = p.o0/(p.pop-p.o0);

%---------------------------
% technology: input from sk and uk separately
%---------------------------
p.L0 = [1922,922+75,7751;	...
		1287,495+269,10999];
p.L0 = p.L0/sum(p.L0,'all');

% low(m,w); high(m,w)
wages = [6.85,	2.06; ...
		9.02,	2.96];
% wages = [4.06	1.85; ...
%         5.33	2.64];

share = [sum(p.L0(:,1:2),2),p.L0(:,3)];
share = wages.*share;
share = sum(share,2);

p.thet = share(2)/share(1)+1;
p.thet = 1/p.thet;

share = wages.*p.L0(:,2:3);
p.alph = share(:,2)./share(:,1)+1;
p.alph = 1./p.alph;

%---------------------------
%% SIR params
%---------------------------
gpara = 1/14;

% toggle to match initial rise
vpara = gpara * 3.9;	%2.177;

% cfr of old
mpara = 0.118181818181818;

%------------
% get sick params
%------------
common_params;

%------------
%% hetero params
%------------
p.yv0 = [	0.087574534118176	-0.458074480295181	0.369783014059067;
			-0.313607513904572	-0.653700530529022	-0.159147143363953];
p.psi0=[	0.183302670717239	0.141791462898254	0.079387187957764;
			0.136352851986885	0.178818076848984	0.105572283267975];
p.lockj = [	0.746266782283783	0.710078656673431	0.689049005508423;
			0.901440918445587	0.817883431911469	0.79921692609787];
gdpd = 0;

% force of infection
% b1+b2 by sector to 3:4 death rate (scotland)
% b1:b2 to match death rate by occ
%p.yb = zeros(p.Ns,p.No-1,p.No-1);
%p.yb(1,:,:) = [0.4,0.2;0.2,0.4];
%p.yb(2,:,:) = [0.5,0.1;0.1,0.5];

p.yv = p.yv0 - sum(p.yv0.*p.L0,'all');
p.yv = -p.yv * vpara/min(p.yv,[],'all');
p.yv = p.yv + vpara;

p.yq = vpara/7;
p.oq = vpara;

% wfh prod
gdp0 = [sum(p.L0(:,1:2),2),p.L0(:,3)];
gdp0= gdp0.*wages;
gdp0 = sum(gdp0,2);

shift = [0.387424095277876;0.267806503904904];
% shift = fsolve(@(x) f.getpsi(x,p,wages,gdp0,gdpd),shift, ...
% 		optimset('display','off','MaxIter',maxit,'MaxFunEvals',maxit ...
% 		));
p.psi = shift.*p.psi0 + (1.-shift).*ones(p.Ns,p.No);

% switch logit extreme values
% only need to run once!
p.qloc = 0.0323247495146324;
p.loc = [ 0        -0.646737192654196          1.74607766660408
          0        -0.513722193924464          2.54595238199877];
runsafe = 0;
common_safe;
if runsafe==1
	format long g
	p.qloc
	p.loc
	format short
	return
end
%------------
%------------

%% base: 1 infection, do nothing
% initialize
Ia = Ia0;
base = safe;
base(1).y0(:,:,1,:) = (1d0-Ia)*safe(1).y0(:,:,1,:);
base(1).y0(:,:,2,:) = Ia*safe(1).y0(:,:,1,:);
base(1).o0(1,:) = (1d0-Ia)*safe(1).o0(1,:);
base(1).o0(2,:) = Ia*safe(1).o0(1,:);
base(2) = base(1);

% policies
for t = 1:p.Nt
	t0 = 0.03;
	t1 = 0.8;
    if (t<30)
        base(t).tau = p.omeg * [0.0;0.0];
    elseif (t<61)	% Jan 20 first detection (21 in Korea)
        base(t).tau = p.omeg * t0 * ones(2,1);
    elseif (t<117)	% Feb 20 SCJ outbreak (19 in Korea)
        base(t).tau = p.omeg * (t0+(t1-t0)*(t-60)/(117-60)) * ones(2,1);
% Apr 18 (117) lifting of restrictions/mass testing.
% May 1 (130) Nightclub incident.
    elseif (t<236)
        base(t).tau = p.omeg * t1 * ones(2,1);
% Aug 15 (236) Seoul restrictions.
    elseif (t<265)
        base(t).tau = p.omeg * t1 * ones(2,1);
% Sep 13 (265) Seoul eases restrictions.
    else
        base(t).tau = p.omeg * t1 * ones(2,1);
% Oct 12 lifting again (Korea Oct 12).
    end
end
base = solvemodel(base,Ia,p);
%----------------------
%% CALIBRATE: shift 1 day earlier for UK time
% INITIAL PEAK
% DEATHS BY SECTOR
% DEATHS BY OCCUPATION
% TESTING RATES
%----------------------
%% high tests and track
%----------------------
% initialize
Ia = Ia0;
track = base;

% policies
for t = 1:p.Nt
	t0 = 0.03;
	t1 = 0.8;
	q0 = 0.1;
	q1 = 0.94;
	q2 = 0.61;
	q3 = 0.9;
	q4 = 0.78;
    if (t<30)
        track(t).tau = p.omeg * [0.0;0.0];
    elseif (t<61)	% Jan 20 first detection (21 in Korea)
        track(t).tau = p.omeg * t0 * ones(2,1);
        track(t).Q = 1;
        track(t).q = q0;
    elseif (t<117)	% Feb 20 SCJ outbreak (19 in Korea)
        track(t).tau = p.omeg * (t0+(t1-t0)*(t-60)/(117-60)) * ones(2,1);
        track(t).Q = 1;
		track(t).q = q1;
% Apr 18 (117) lifting of restrictions/mass testing.
% May 1 (130) Nightclub incident.
    elseif (t<236)
        track(t).tau = p.omeg * t1 * ones(2,1);
        track(t).Q = 1;
		track(t).q = q2 + f.mit(t,117,236,3)* (q1-q2);
% Aug 15 (236) Seoul restrictions.
    elseif (t<265)
        track(t).tau = p.omeg * t1 * ones(2,1);
        track(t).Q = 1;
		track(t).q = q3 + f.mit(t,236,265,2)* (q2-q3);
% Sep 13 (265) Seoul eases restrictions.
    else
        track(t).tau = p.omeg * t1 * ones(2,1);
        track(t).Q = 1;
		track(t).q = q4 + f.mit(t,265,265+58,2)* (q3-q4);
% Oct 12 lifting again (Korea Oct 12).
    end
end
track = solvemodel(track,Ia,p);

	
%% lockdown
% initialize
Ia = Ia0;
lock = base;

% policies
for t = 1:p.Nt
	lock(t).j = f.mit(t,93,93+ld0,ld1);
	t0 = 0.0001;
	t1 = 0.03;
	t2 = 0.3;
	q1 = 0.55;
    if (t<42)
        lock(t).tau = p.omeg * [0.0;0.0];
    elseif (t<51)	% Feb 1	first detection	(Jan 31 in Korea)
    	lock(t).tau = p.omeg * [0.00;t0];
    elseif (t<65)	% Feb 10 first quarantine
    	lock(t).tau = p.omeg * [0.00;t0];
        lock(t).Q = 1;
    elseif (t<93)	% Feb 24 testing restarts
    	lock(t).tau = p.omeg * [0.00;t0+(t1-t0)*(t-64)/(92-64)];
        lock(t).Q = 1;
%    elseif (t<124)	% Mar 23 lockdown
%    	lock(t).tau = p.omeg * [0.00;t1+(t2-t1)*(t-92)/(161-92)];
%        lock(t).Q = 2;
%        lock(t).q = q1;%	q1*(t-92)/(124-92);
    else	% Apr 23 a-testing starts (124) / May 30: mass track and trace in place
        lock(t).tau = p.omeg * [0.00;t1+(t2-t1)*(t-92)/(161-92)];%t0*(t-123)/(161-123)
        lock(t).Q = 2;
        lock(t).q = q1;
    end
end
lock = solvemodel(lock,Ia,p);

%% PLOTS 
r = skuk_data(1,append(folder,'sk_data.pdf'));
r.style = {'linewidth','linestyle','color'};
r.stime = [1:p.Nt];
if p.Nt==365
    r.xtnum = [31:60:p.Nt];
    r.xtlab = {'Jan 21','Mar 21','May 20','Jul 19','Sep 17','Nov 16'};
else
    r.xtnum = [31:120:p.Nt];
    r.xtlab = {'Mar 21','Jul 19','Nov 16','Mar 16','Jul 14','Nov 11'};
end    
legnom = {'Model','No policy','Lockdown'};
legnom2 = {'Model','A. Testing','No policy','Q. Enforce','Lockdown'};
vals = {3,3,3;'-',':','--';'k',[.7 .7 .7],[.4 .4 .4]}';
vals2 = {3,3,3,3,3;'-',':','--','--',':';'k',[.8 .8 .8],[.5 .5 .5],'k',[.2 .2 .2]}';

baseg = plots(base,p,r,append(folder,'sk_base'));
trackg = plots(track,p,r,append(folder,'sk_track'));
lockg = plots(lock,p,r,append(folder,'sk_lock'));

% ALL PLOTS
sk_sir(:,1) = trackg.SIR(:,2);%-trackg.SIR(:,3);
sk_sir(:,2) = baseg.SIR(:,2);%-baseg.SIR(:,3);
sk_sir(:,3) = lockg.SIR(:,2);%-lockg.SIR(:,3);
    
sk_death(:,1) = trackg.D01(:,1);
sk_death(:,2) = baseg.D01(:,1);
sk_death(:,3) = lockg.D01(:,1);

sk_gdp(:,1) = trackg.prod(:,3);
sk_gdp(:,2) = baseg.prod(:,3);
sk_gdp(:,3) = lockg.prod(:,3);

h2 = figure('color','w');
p2 = semilogy(r.stime,sk_death*p.pop); hold on;
set(p2,r.style,vals)
legend(p2,legnom,'location','southoutside','NumColumns',3);
xlim([1 p.Nt]);xticks(r.xtnum);xticklabels(r.xtlab); 
ylim([1, Inf]);
set(gca,'fontsize',12');     
grid on
% saveas(h2,append(folder,'sk_cf_death.pdf'));

h3 = figure('color','w');
p3 = plot(r.stime,sk_gdp); hold on;
set(p3,r.style,vals)
legend(p3,legnom,'location','southoutside','NumColumns',3);
xlim([1 p.Nt]);xticks(r.xtnum);xticklabels(r.xtlab); 
ylim([-Inf,0]);
set(gca,'fontsize',12');     
grid on
% saveas(h3,append(folder,'sk_cf_gdp.pdf'));
    
close all
addpath('.');

cd figures_sk
% %cd figures_nocc
% %cd figures_nome
% 
!find -name "*base*.pdf" -exec pdfcrop {} \;
!find -name "*track*.pdf" -exec pdfcrop {} \;
!find -name "*lock*.pdf" -exec pdfcrop {} \;
!find -name "*data*.pdf" -exec pdfcrop {} \;
!find -name "*cf_*.pdf" -exec pdfcrop {} \;
!rename -f 's/-crop.pdf/.pdf/' *-crop.pdf;
%!rename -f 's/base/sk_base/' base*;
%!rename -f 's/track/sk_track/' track*;
%!rename -f 's/lock/sk_lock/' lock*;
cd ..


%----------------------
%% test without tracking
%----------------------
% initialize
Ia = Ia0;
test = base;
 
% policies
for t = 1:p.Nt
	t0 = 0.03;
	t1 = 0.8;
	q0 = 0.1;
	q1 = 0.55;
	q2 = 0.55;
	q3 = 0.55;
	q4 = 0.55;
    if (t<30)
        test(t).tau = p.omeg * [0.0;0.0];
    elseif (t<61)	% Jan 20 first detection (21 in Korea)
        test(t).tau = p.omeg * t0*ones(2,1);
        test(t).Q = 1;
        test(t).q = q0;
    elseif (t<117)	% Feb 20 SCJ outbreak (19 in Korea)
        test(t).tau = p.omeg * (t0+(t1-t0)*(t-60)/(117-60)) * ones(2,1);
        test(t).Q = 1;
		test(t).q = q1;
% Apr 18 (117) lifting of restrictions/mass testing.
% May 1 (130) Nightclub incident.
    elseif (t<236)
        test(t).tau = p.omeg * t1 * ones(2,1);
        test(t).Q = 1;
		test(t).q = q2 + f.mit(t,117,236,3)* (q1-q2);
% Aug 15 (236) Seoul restrictions.
    elseif (t<265)
        test(t).tau = p.omeg * t1 * ones(2,1);
        test(t).Q = 1;
		test(t).q = q3 + f.mit(t,236,265,2)* (q2-q3);
% Sep 13 (265) Seoul eases restrictions.
    else
        test(t).tau = p.omeg * t1 * ones(2,1);
        test(t).Q = 1;
		test(t).q = q4 + f.mit(t,265,265+58,2)* (q3-q4);
% Oct 12 lifting again (Korea Oct 12).
    end
end
test = solvemodel(test,Ia,p);
 
%----------------------
%% track without testing
%----------------------
% initialize
Ia = Ia0;
isol = base;

% policies
for t = 1:p.Nt
	t0 = 0.03;
	t1 = 0.8;
	q0 = 0.1;
	q1 = 0.94;
	q2 = 0.61;
	q3 = 0.9;
	q4 = 0.78;
    if (t<30)
        isol(t).tau = p.omeg * [0.0;0.0];
    elseif (t<61)	% Jan 20 first detection (21 in Korea)
        isol(t).tau = p.omeg * t0 * [0;1];
        isol(t).Q = 1;
        isol(t).q = q0;
    elseif (t<117)	% Feb 20 SCJ outbreak (19 in Korea)
        isol(t).tau = p.omeg * (t0+(t1-t0)*(t-60)/(117-60)) * [0;1];
        isol(t).Q = 1;
		isol(t).q = q1;
% Apr 18 (117) lifting of restrictions/mass testing.
% May 1 (130) Nightclub incident.
    elseif (t<236)
        isol(t).tau = p.omeg * t1 * [0;1];
        isol(t).Q = 1;
		isol(t).q = q2 + f.mit(t,117,236,3)* (q1-q2);
% Aug 15 (236) Seoul restrictions.
    elseif (t<265)
        isol(t).tau = p.omeg * t1 *[0;1];
        isol(t).Q = 1;
		isol(t).q = q3 + f.mit(t,236,265,2)* (q2-q3);
% Sep 13 (265) Seoul eases restrictions.
    else
        isol(t).tau = p.omeg * t1 * [0;1];
        isol(t).Q = 1;
		isol(t).q = q4 + f.mit(t,265,265+58,2)* (q3-q4);
% Oct 12 lifting again (Korea Oct 12).
    end
end
isol = solvemodel(isol,Ia,p);

% ALL PLOTS
testg = plots(test,p,r,append(folder,'sk_test'));
isolg = plots(isol,p,r,append(folder,'sk_isol'));

sk_sir(:,4) = isolg.SIR(:,2);%-lockg.SIR(:,3);
sk_sir(:,5) = sk_sir(:,3);
sk_sir(:,3) = sk_sir(:,2);
sk_sir(:,2) = testg.SIR(:,2);%-baseg.SIR(:,3);
    
sk_death(:,4) = isolg.D01(:,1);
sk_death(:,5) = sk_death(:,3);
sk_death(:,3) = sk_death(:,2);
sk_death(:,2) = testg.D01(:,1);

% sk_gdp(:,4) = isolg.D01(:,1);
% sk_gdp(:,5) = sk_gdp(:,3);
% sk_gdp(:,3) = sk_gdp(:,2);
% sk_gdp(:,2) = testg.D01(:,1);

sk_gdp(:,4) = isolg.prod(:,3);
sk_gdp(:,5) = sk_gdp(:,3);
sk_gdp(:,3) = sk_gdp(:,2);
sk_gdp(:,2) = testg.prod(:,3);

h2 = figure('color','w');
p2 = semilogy(r.stime,sk_death*p.pop); hold on;
set(p2,r.style,vals2)
legend(p2,legnom2,'location','southoutside','NumColumns',3);
xlim([1 p.Nt]);xticks(r.xtnum);xticklabels(r.xtlab); 
ylim([1, Inf]);
set(gca,'fontsize',12');     
grid on
saveas(h2,append(folder,'sk_cf1_death.pdf'));

h3 = figure('color','w');
p3 = plot(r.stime,sk_gdp); hold on;
set(p3,r.style,vals2)
legend(p3,legnom2,'location','southoutside','NumColumns',3);
xlim([1 p.Nt]);xticks(r.xtnum);xticklabels(r.xtlab); 
ylim([-Inf, 0]);
set(gca,'fontsize',12');     
grid on
saveas(h3,append(folder,'sk_cf1_gdp.pdf'));
    
close all
addpath('.');

cd figures_sk
% %cd figures_nocc
% %cd figures_nome
% 
!find -name "*test*.pdf" -exec pdfcrop {} \;
!find -name "*isol*.pdf" -exec pdfcrop {} \;
!find -name "*cf1*.pdf" -exec pdfcrop {} \;
!rename -f 's/-crop.pdf/.pdf/' *-crop.pdf;
%!rename -f 's/test/sk_test/' test*;
%!rename -f 's/isol/sk_isol/' isol*;
cd ..

nmax = r.xaxis(end);
sk_tab(1,:) = floor(sk_death(nmax,:)*p.pop+0.5);
sk_tab(2,:) = sum(sk_gdp(31:nmax,:),1)/(nmax-30);

save sk_results